unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


uses AclApi,tlhelp32;

procedure ListerProcessus(ListBox: TCustomListBox);
var
  SnapShot: Cardinal;
  ProcessEntry: TProcessEntry32;
begin
  SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  If SnapShot = 0 then Exit;
  ProcessEntry.dwSize := SizeOf(ProcessEntry);
  If Process32First(SnapShot, ProcessEntry) then
  begin
    ListBox.Items.Add(ProcessEntry.szExeFile);
    while Process32Next(SnapShot, ProcessEntry) do
      ListBox.Items.Add(ProcessEntry.szExeFile);
  end;
  CloseHandle(SnapShot);
end;

function IdByProcessus(const ExeFile: string):Longword;
var
  SnapShot: Cardinal;
  ProcessEntry: TProcessEntry32;
  label find,loop;
begin
  result := 0;
  SnapShot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  If SnapShot = 0 then Exit;
  ProcessEntry.dwSize := SizeOf(ProcessEntry);
  If Process32First(SnapShot, ProcessEntry) then
  begin
    loop:
    if ansisametext(ProcessEntry.szExeFile,ExeFile) then
     begin
     result := ProcessEntry.th32ProcessID;
     goto find;
     end;
    if Process32Next(SnapShot, ProcessEntry) then goto loop;
  end;
  find:
  CloseHandle(SnapShot);
end;



function EnableProcessPrivilege(const Enable: Boolean; const Privilege:
string): Boolean;
const
  PrivAttrs: array [Boolean] of DWORD = (0, SE_PRIVILEGE_ENABLED);
var
  Token: THandle;
  ReturnLength: Cardinal;
  TokenPriv: TTokenPrivileges;
begin
  Result := False;
  if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, Token)
then
  begin
    TokenPriv.PrivilegeCount := 1;
    LookupPrivilegeValue(nil, PChar(Privilege),
TokenPriv.Privileges[0].Luid);
    TokenPriv.Privileges[0].Attributes := PrivAttrs[Enable];
    AdjustTokenPrivileges(Token, False, TokenPriv, SizeOf(TokenPriv), nil,
ReturnLength);
    Result := GetLastError = ERROR_SUCCESS;
    CloseHandle(Token);
  end;
end;

function LookupAccountBySid(Sid: PSID): string;
var
  Name, RefDomain: string;
  NameSize, RefDomainSize: DWORD;
  Use: Cardinal;
begin
  NameSize := 0;
  RefDomainSize := 0;
  LookupAccountSid(nil, Sid, nil, NameSize, nil, RefDomainSize, Use);
  SetLength(Name, NameSize);
  SetLength(RefDomain, RefDomainSize);
  LookupAccountSid(nil, Sid, PChar(Name), NameSize, PChar(RefDomain),
RefDomainSize, Use);
  Result := PChar(RefDomain) + '/' + PChar(Name);
end;

procedure QueryTokenInformation(Token: THandle; InformationClass:
TTokenInformationClass; var Buffer: Pointer);
var
  B: BOOL;
  Length: DWORD;
begin
  Buffer := nil;
  Length := 0;
  B := GetTokenInformation(Token, InformationClass, Buffer, Length, Length);
  while (not B) and (GetLastError = ERROR_INSUFFICIENT_BUFFER) do
  begin
    ReallocMem(Buffer, Length);
    B := GetTokenInformation(Token, InformationClass, Buffer, Length,
Length);
  end;
  if not B then
  begin
    FreeMem(Buffer);
    Buffer := nil;
    raise Exception.Create('Unable to get token information');
  end;
end;

type
  PTokenUser = ^TTokenUser;
  TTokenUser = record
    User: TSidAndAttributes;
  end;

function GetProcessUser(const PID: Longword): string;
var
  Token, Handle: THandle;
  User: PTokenUser;
begin
  Handle := OpenProcess(PROCESS_QUERY_INFORMATION, False, PID);
  if Handle <> 0 then
  begin
    if OpenProcessToken(Handle, TOKEN_QUERY, Token) then
    begin
      QueryTokenInformation(Token, TokenUser, Pointer(User));
      Result := LookupAccountBySid(User.User.Sid);
      FreeMem(User);
      CloseHandle(Token);
    end;
    CloseHandle(Handle);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  EnableProcessPrivilege(True, 'SeDebugPrivilege');
  ListerProcessus(listbox1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Memo1.Lines.Append(GetProcessUser(IdByProcessus(edit1.text)));
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
edit1.Text := listbox1.items[listbox1.itemindex];
end;

end.
 